<template>
  <NodeViewWrapper class="mx-2">
    <ImageUploader
      @file-uploaded="onUpload"
      @error="onError"
    />
  </NodeViewWrapper>
</template>

<script setup>
import axios from "axios";
import { defineProps } from 'vue';
import ImageUploader from './ImageUploader.vue';
import { nodeViewProps, NodeViewWrapper } from '@tiptap/vue-3';

const { getPos, editor, node } = defineProps(nodeViewProps);

const loadXHR = (url) => {
  return new Promise(function (resolve, reject) {
    try {
      const xhr = new XMLHttpRequest();
      xhr.open("GET", url);
      xhr.responseType = "blob";
      xhr.onerror = function () {
        reject("Network error.")
      };
      xhr.onload = function () {
        if (xhr.status === 200) {
          const file = new File([xhr.response], `tmp-${new Date()}`);
          resolve(file)
        } else {
          reject("Loading error:" + xhr.statusText)
        }
      };
      xhr.send();
    } catch (err) {
      reject(err.message)
    }
  });
}

const onError = () => {
  editor.chain().setImageBlockError().deleteRange({ from: getPos(), to: getPos() }).focus().run();
}

const onUpload = async (url) => {
  if (url) {
    if ((/^(\S+):(\/\/)?\S+$/.test(url))) {
      try {
        editor.chain().setImageBlockLoading({ src: url, progress: 0 }).deleteRange({ from: getPos(), to: getPos() }).focus().run();
        const tmpFile = await loadXHR(url)
        const config = {
          onUploadProgress: (progressEvent) => {
            const { loaded, total } = progressEvent;
            const percent = Math.floor((loaded * 100) / total)
            if(percent <= 100) {
              editor.commands.updateAttributes("imageBlockLoading", { progress: percent })
            }
          },
          headers: { 'Content-Type': 'multipart/form-data' }
        }
        let createImageUrl = localStorage.getItem("SvnTiptapCreateImageUrl")
        if (createImageUrl) {
          const { data } = await axios.post(JSON.parse(createImageUrl),
            { image: tmpFile },
            config
          );
          editor.chain().setImageBlock({ src: data.file?.['url'] }).deleteRange({ from: getPos(), to: getPos() }).focus().run();
        } else {
          onError()
        }
      } catch (error) {
        onError()
        console.log('Error uploading image: ', error);
      }
    } else {
      onError()
    }
  } else {
    onError()
  }
};
</script>
